/* ATMega8 */
/* DCF-Dekoder und Temperaturfhler fr 2 DS1621 mit Ausgabe auf Display*/

#include <avr/signal.h>
#include <stdio.h>
#include <avr/io.h>
#include "lcd_io.h"
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <stdlib.h>
#include <string.h>
#include <i2cmaster.h>
#define Dev1621_1  0x90      // device address of DS1621-1
#define Dev1621_2  0x92      // device address of DS1621-2
typedef unsigned char  BYTE;
typedef unsigned int WORD;
#define F_CPU 			3000000
BYTE nSek;				/*Sekundenzahler vom timer*/
BYTE nSek1;				/* Sekundenzhler vom DCF-Takt*/
BYTE nMin=0;
BYTE nStd=0;

BYTE nTag;
BYTE nWTag;
BYTE nMonat;
BYTE nJahr;

BYTE Bitauswertung=0;
BYTE Parzaehler=0;
BYTE Timer1Wert=0;
WORD Sekundenwert=46875;
BYTE Sekunde59;
BYTE Inputstring=0;

const char error[1][7]PROGMEM ={" XX.X "};
const char temp[2][5]PROGMEM ={",5 C",",0 C"};
const char tag[8][3]PROGMEM ={"Mo","Di","Mi","Do","Fr","Sa","So","20"};
const char fuell[5][2]PROGMEM ={"0",".","-"," ",":"};/* Texte fr die LCD-Ausgabe im Flash*/

char Zeit[5];
void dcfbit_rec (void);
void I2C_Temp (void);
void Biterkennung (void);
void Sekundentakt(void);
struct {
	unsigned char Intstat :1;			//Interrupt 0 auslsen bei fallender Flanke =1 bei steigender =0
	unsigned char dcfstat :2;			//Paritycheck OK = 0 
	unsigned char Sekunde59 :1;		//Sekunde 59 erkannt
	volatile unsigned char lcdset :1;//Wird gesetzt wenn LCD anzeige gendert werden soll
	unsigned char ret_1:1;			// Returwert von I2C Device 1
	unsigned char ret_2:1;			// Returwert von I2C Device 2
}DCF;
SIGNAL(SIG_OVERFLOW0){					//Takt fr Bitauswertung
	Bitauswertung++;					//Zhler fr bitauswertung
	Sekunde59++;						//Zhler fr Sekunde59
	}
SIGNAL(SIG_OUTPUT_COMPARE1A){			//Sekundentakt
	Sekundentakt();
	}
	void Sekundentakt(void){
	nSek++;								//Sekundenzhler um 1 erhhen
	DCF.lcdset=1;						//LCD-Ausgabe aktiv
	TCCR1B=0;							// Timer 1 stoppen
	TCNT1=0;							// Timer 1 auf 0 stellen
	OCR1A=Sekundenwert;		//OC-Register auf 1 sec. eingestellt, genau einstellen, Takt wenn DCF fehlt
	TCCR1B=(1<<CS10)|(1<<CS11);		//timer 1 auf teiler 64 eingestellt, Start
	I2C_Temp ();						//I2c Routine aufrufen
	if (PORTD &16){
		cbi(PORTD,4);					//LED Sekundentakt toggeln
	}
	else{
	sbi(PORTD,4);
	}
}
SIGNAL(SIG_INTERRUPT0){					//Interrupt bei fallender oder steigender Flanke des DCF-Signals
	Timer1Wert=Bitauswertung;			
	Biterkennung ();					//Programm Biterkennung aufrufen
}
void Biterkennung (void){
	if (DCF.Intstat){					//Abfrage ob fallende Flanke
		Bitauswertung=0;				
		Timer1Wert=0;
		MCUCR=(1<<ISC01)|(1<<ISC00);  //Interrupt 0 auslsen bei steigender Flanke an int0	
		DCF.Intstat=0;					//Interruptstatus auf 0 gestellt
		if (DCF.Sekunde59){			//Bit Sekunde 59 gesetzt
			Sekunde59=0;				
			nSek1=0;					//Sekundenzhler fr Bitauswertung auf 0 setzten
			DCF.Sekunde59=0;
		}
		else{
			Sekunde59=0;
			DCF.Sekunde59=0;
			nSek1++	;					//Sekundenzhler fr Bitauswertung um 1 erhhen
		}
	}
	else if ((Timer1Wert>=3)&&(Timer1Wert<=6)){	//Abfrage ob 0	Wenn steigende Flanke 
		MCUCR=(1<<ISC01);               //Interrupt 0 auslsen bei fallender Flanke an int0 einstellen
		DCF.Intstat=1;						//Interrupt 0 auslsen bei fallender Flanke erkennung ein
		Inputstring >>=1;					// Eine 0 nach rechts in den String schieben
		cbi (PORTD,5);						// Anzeige 1 erkannt lschen
		dcfbit_rec ();						//Unterprogramm Bitauswertung aufrufen
	}
	else if ((Timer1Wert>=7)&&(Timer1Wert<=11)){	//Abrage ob 1
		MCUCR=(1<<ISC01);               //Interrupt 0 auslsen bei fallender Flanke an int0 einstellen
		DCF.Intstat=1;						//Interrupt 0 auslsen bei fallender Flanke erkennung ein
		Inputstring >>=1;					// Eine 0 nach rechts in den String schieben
		Inputstring=Inputstring |0x80;		// Die 0 durc eine 1 ersetzen
		Parzaehler ++;						//Zhlt die 1er fr die Parittsberprfung
		sbi (PORTD,5);						//Anzeige 1 erkannt setzen
		dcfbit_rec ();						//Unterprogramm Bitauswertung aufrufen
	}
	else {
		DCF.dcfstat = 2;					//Taktzeit nicht im Rahmen, Auswertung wird blockiert
		MCUCR=(1<<ISC01);               	//Interrupt 0 auslsen bei fallender Flanke an int0 einstellen
		DCF.Intstat=1;						//Interrupt 0 auslsen bei fallender Flanke erkennung ein
		cbi(PORTD,3);						//Anzeige DCF-Status OK lschen
	}	
}
void dcfbit_rec (void){					//Auswertung der aufgenommenen Sekundenbit
static BYTE Min_e;
static BYTE Min;
static BYTE Std_e;
static BYTE Std;
static BYTE WTag;
static BYTE Tag;
static BYTE Tag_e;
static BYTE Monat;
static BYTE Monat_e;
static BYTE Jahr_e;
static BYTE Jahr;
	switch (nSek1) {
		case 19:						//Parzhler auf 0 stellen
			Parzaehler=0;
		break;
		case 20:
			if(Parzaehler){			//Abfrage ob bit-20 1 oder 0  wenn 1 Startbit
				Parzaehler=0;
				Inputstring=0;
			}
			else {
				DCF.dcfstat=2;			//Wenn Fehler DCF-Status auf 2
				cbi(PORTD,3);
				}
		break;
		case 24:						//Minuten Einerstelle
			Inputstring >>=4;			//Inputstring wird um 4 Stellen nach rechts geschoben
			Min_e=Inputstring;			//Die Minuten-Einerstellen werden zwischengespeichert
			Inputstring=0;
		break;
		case 28	:						//Minute Zehnerstelle und Paritt
			if(Parzaehler % 2 == 0){ 	//Paritaetsabfrage
				Inputstring <<=1;		//Das Parttsbit wird links hinausgeschoben
				Inputstring >>=5;		//Inputstring wird um 5 Stellen nach rechts geschoben
				Min=Inputstring*10+Min_e;//Der Inputstring wird umgerechnet und kommt in die Minutenausgabe
			}
			else{
			DCF.dcfstat=2;				//Bei Parittsfehler wird der DCF-Status 2
			cbi(PORTD,3);
			}
			Inputstring=0;					//Inputstring auf 0 setzten
			Parzaehler=0;					//Parittszhler auf 0 setzten
		break;
		case 32:						//Stunden Einerstelle 
			Inputstring >>=4;			//Inputstring wird um 4 Stellen nach rechts geschoben
			Std_e=Inputstring;			//Stundeneinerwert in den Zwischenspeicher
			Inputstring=0;
		break;	
		case 35	:						//Stunden Zehnerstelle und Paritt
			if(Parzaehler % 2 == 0){ 	//Paritaetsabfrage
				Inputstring <<=1;		//Das Parttsbit wird links hinausgeschoben
				Inputstring >>=6;		//Inputstring wird um 6 Stellen nach rechts geschoben
				Std=Inputstring*10+Std_e;//Der Inputstring wird umgerechnet und kommt in die Stundenausgabe
			}
			else{
				DCF.dcfstat=2;				//Bei Parittsfehler wird der DCF-Status 2
				cbi(PORTD,3);
			}
			Inputstring=0;				//Inputstring auf 0 setzten
			Parzaehler=0;				//Parittszhler auf 0 setzten
		break;
		case 39:					//Tag Einerstelle
			Inputstring >>=4;		//String um 4 Stellen nach rechts
			Tag_e=Inputstring;		//Tag-Einerwert in den Zwischenspeicher
			Inputstring=0;
		break;	
		case 41:					//Tag
			Inputstring >>=6;
			Tag=Inputstring*10+Tag_e;//Der Inputstring wird umgerechnet und kommt in die Tagesausgabe
			Inputstring=0;
		break;
		case 44	:					//Wochentag
			Inputstring >>=5;
			WTag=Inputstring;		// Inputstring in den wochentagzwischenspeicher
			Inputstring=0;
		break;
		case 48:					//Monat Einerstelle
			Inputstring >>=4;		//String um 4 Stellen nach rechts
			Monat_e=Inputstring;	//Monat-Einerwert in den Zwischenspeicher
			Inputstring=0;
		break;	
		case 49	:					//Monat Zehnerstelle
			Inputstring >>=7;
			Monat=Inputstring*10+Monat_e;//Der Inputstring wird umgerechnet und kommt in die Monatsausgabe
			Inputstring=0;
		break;
		case 53:					//Jahr Einerstelle
			Inputstring >>=4;		//String um 4 Stellen nach rechts
			Jahr_e=Inputstring;		//Jahr-Einerwert in den Zwischenspeicher
			Inputstring=0;
		break;	
		case 58	:					//Jahr Zehnerstelle und Paritt
			if(Parzaehler % 2 == 0){ //Paritaetsabfrage	
				Inputstring <<=1;		//Das Parttsbit wird links hinausgeschoben
				Inputstring >>=4;		//Der String um 4 Schritte nach rechts
				Jahr=Inputstring*10+Jahr_e;//Der Inputstring wird umgerechnet und kommt in den Jahreszwischenspeicher	
			}
			else{
				DCF.dcfstat=2;			//Bei Parittsfehler wird der DCF-Status 2
				cbi(PORTD,3);
			}
		break;
		case 0:					// Anzeigennderung bei 0 Sekunden
			if(DCF.dcfstat==0){
				nSek=0;					// Sekunden auf 0 stellen
				nMin=Min;				//Der Minutenzwischenspeicher in die Minutenausgabe
				nStd=Std;				//Der Stundenzwischenspeicher in die Stundenausgabe
				nTag=Tag;				//Der Tagzwischenspeicher Tagausgabe
				nWTag= WTag;			//Der wochentagszwischenspeicher in den wochentagsspeicher
				nMonat=Monat;			//Der Monatzwischenspeicher in die Monatsausgabe
				nJahr=Jahr;				//Der Jahreszwischenspeicher in die Jahresausgabe
				sbi(PORTD,3);
			}
			else{
			DCF.dcfstat--;				//Zhler dcfstat um 1 verringern
			}
		break;
	}
}	
void I2C_Temp (void) {
BYTE Temp_h=0;
BYTE Temp_l=0;
BYTE Temperatur[5];
DCF.ret_1 = i2c_start(Dev1621_1+I2C_WRITE);       // set device address and write mode
	if ( DCF.ret_1 ) {							//Prft ob DS1621 vorhanden
		i2c_stop();								// set stop conditon = release bus
		lcd_gotoxy(15,0);
		lcd_puts_p(error[0]);           	 // Schreibt Fehler ins Display
	}
	else {
		i2c_write(0xee);
		i2c_rep_start(Dev1621_1+I2C_WRITE);
		i2c_write(0xaa);						// Schreibt "aa" Temperatur lesen
		i2c_rep_start(Dev1621_1+I2C_READ);		// Startet den Lesevorgang
		Temp_h=i2c_readAck();                  // liest erstes Byte	
		Temp_l=i2c_readNak();					//liest zweites Byte
		i2c_stop();                            // set stop conditon = release bus
		lcd_gotoxy(15,0);						
		if (Temp_h >128){
			Temp_h= ~Temp_h;
			lcd_puts_p(fuell[2]);
		}
		else{
			lcd_puts_p(fuell[3]);
		}
		itoa(Temp_h,Temperatur,10);
		if (strlen(Temperatur)==1){
			lcd_puts_p(fuell[3]);
		}
		lcd_puts(Temperatur);
		if (Temp_l >0){
			lcd_puts_p(temp[0]);
		}
		else{
			lcd_puts_p(temp[1]);
		}
	}
DCF.ret_2 = i2c_start(Dev1621_2+I2C_WRITE);      // set device address and write mode
	if ( DCF.ret_2 ) {							//Prft ob DS1621 vorhanden
		i2c_stop();								// set stop conditon = release bus
		lcd_gotoxy(15,1);
		lcd_puts_p(error[0]);            		// Schreibt Fehler ins Display
	}
	else {
		i2c_write(0xee);
		i2c_rep_start(Dev1621_2+I2C_WRITE);
		i2c_write(0xaa);						// Schreibt "aa" Temperatur lesen
		i2c_rep_start(Dev1621_2+I2C_READ);		// Startet den Lesevorgang
		Temp_h=i2c_readAck();                  // liest erstes Byte	
		Temp_l=i2c_readNak();					//liest zweites Byte
		i2c_stop();                            // set stop conditon = release bus
		lcd_gotoxy(15,1);						
		if (Temp_h >128){						//Wenn bit 9 gesetzt Minus anzeigen
			Temp_h= ~Temp_h;
			lcd_puts_p(fuell[2]);
		}
		else{
			lcd_puts_p(fuell[3]);
		}
		itoa(Temp_h,Temperatur,10);
		if (strlen(Temperatur)==1){
			lcd_puts_p(fuell[3]);
		}
		lcd_puts(Temperatur);
		if (Temp_l >0){
			lcd_puts_p(temp[0]);
		}
		else{
			lcd_puts_p(temp[1]);
		}
	}		
}
int main (void){
DDRD=0xfb;
PORTD=0x04;
lcd_init();							//Init LCD
i2c_init(); 			 			// init I2C interface 
i2c_start(Dev1621_1+I2C_WRITE); 	// Startet den I2C-Bus
i2c_write(0xee);					//initialsiert den DS1621 fr Temperaturausgabe
i2c_stop();							// Stopt den I2C-Bus
i2c_start(Dev1621_2+I2C_WRITE); 	// Startet den I2C-Bus
i2c_write(0xee);					//initialsiert den DS1621 fr Temperaturausgabe
i2c_stop();							// Stopt den I2C-Bus
cli();
MCUCR=(1<<ISC01);               	//Interrupt 0 auslsen bei fallender Flanke an int0
GIMSK=(1<<INT0);  					//Interrupt 0 wird aktiviert
DCF.Intstat = 1;
DCF.dcfstat=1;
DCF.lcdset=1;
	TIMSK=(1<<TOIE0)|(1<<OCIE1A);	// overflow Interrupt Timer0 und compair match Interrupt Timer1 aktiviert
	TCCR1B=0;						// Timer 1 stoppen
	TCNT1=0;						// Timer 1 auf 0 stellen
	OCR1A=Sekundenwert;				//OC-Register auf 1 sec. eingestellt, genau einstellen, Takt wenn DCF fehlt
	TCCR1B=(1<<CS10)|(1<<CS11);	//timer 1 auf teiler 64 eingestellt, Start
	TCCR0=0;						//Timer 0 stopp
	TCNT0=0;						//Timer 0 auf 0 stellen
	TCCR0=(1<<CS02);				//Timer 0 auf teiler 256 stellen Start
sei();

	for(;;){
		if(Sekunde59 >=60){		//Erkennung Sekunde 59
			DCF.Sekunde59=1;
			Sekunde59=0;
		}
		if (DCF.lcdset){			//Zeitzhler wenn nicht sysnchron und ausgabe aufs Display
			if (nSek >= 60){
				nMin++;
				nSek=0;
				if (nMin >=60){
					nStd++;
					nMin=0;
					if (nStd >=24){
						nTag++;
						nWTag++;
						nStd=0;
						if (nTag >=31){
							nTag=0;
						}
						if (nWTag>=8){
							nWTag=1;
						}
					}
				}
			}		
			lcd_gotoxy(0,0);
			itoa(nStd,Zeit,10);
			if (strlen(Zeit)==1){
				lcd_puts_p(fuell[0]);		/* Wenn die Stunde einstellig, fhrende Null ausgeben*/
				}
			lcd_puts(Zeit);				/* Stunde ausgeben*/
			lcd_puts_p(fuell[4]);			/* Doppelpunkt nach Stunde ausgeben*/
			itoa(nMin,Zeit,10);
			if (strlen(Zeit)==1){
				lcd_puts_p(fuell[0]);		/*Wenn die Minute einstellig, fhrende Null ausgeben*/
				}
			lcd_puts(Zeit);				/* Minute ausgeben*/
			lcd_puts_p(fuell[4]);			/* Doppelpunkt nach Minute ausgeben*/
			itoa(nSek,Zeit,10);
			if (strlen(Zeit)==1){
				lcd_puts_p(fuell[0]);		/*Wenn die Sekunde einstellig, fhrende Null ausgeben*/
				}
			lcd_puts(Zeit);				/* Sekunde ausgeben*/
			lcd_gotoxy(0,1);
			switch (nWTag) {			/* den entsprechenden Wochentag ausgeben*/
				case 1:
				lcd_puts_p(tag[0]);
				break;
				case 2:
				lcd_puts_p(tag[1]);
				break;
				case 3:
				lcd_puts_p(tag[2]);
				break;
				case 4:
				lcd_puts_p(tag[3]);
				break;
				case 5:
				lcd_puts_p(tag[4]);
				break;
				case 6:
				lcd_puts_p(tag[5]);
				break;
				case 7:
				lcd_puts_p(tag[6]);
				break;
			}
			lcd_gotoxy(3,1);
			itoa(nTag,Zeit,10);
			if (strlen(Zeit)==1){
				lcd_puts_p(fuell[0]);	/* Wenn Datum Tag einstellig fhrende Null*/
			}
			lcd_puts(Zeit);			/*Ausgabe Datum Tag*/
			lcd_puts_p(fuell[1]);		/*Ausgabe Dezimalpunkt nach Tag*/
			itoa(nMonat,Zeit,10);
			if (strlen(Zeit)==1){
				lcd_puts_p(fuell[0]);	/* Wenn Datum Monat einstellig fhrende Null*/
			}
			lcd_puts(Zeit);			/*Ausgabe Datum Monat*/
			lcd_puts_p(fuell[1]);		/*Ausgabe Dezimalpunkt nach Monat*/
			lcd_puts_p(tag[7]);		/* Die ersten beiden Stellen von Jahr ausgeben*/
			itoa(nJahr,Zeit,10);
			if (strlen(Zeit)==1){
				lcd_puts_p(fuell[0]);	/*wenn die zehnerstelle eine Null ist diese ausgeben*/
			}
			lcd_puts(Zeit);			/* Ausgabe Datum Jahr*/
			DCF.lcdset=0;			/* Flag fr LCD-Ausgabe auf 0*/
		}
	}
}
